//### This file created by BYACC 1.8(/Java extension  1.1)
//### Java capabilities added 7 Jan 97, Bob Jamison
//### Updated : 27 Nov 97  -- Bob Jamison, Joe Nieten
//###           01 Jan 98  -- Bob Jamison -- fixed generic semantic constructor
//###           01 Jun 99  -- Bob Jamison -- added Runnable support
//###           06 Aug 00  -- Bob Jamison -- made state variables class-global
//###           03 Jan 01  -- Bob Jamison -- improved flags, tracing
//###           16 May 01  -- Bob Jamison -- added custom stack sizing
//### Please send bug reports to rjamison@lincom-asg.com
//### static char yysccsid[] = "@(#)yaccpar	1.8 (Berkeley) 01/20/90";



package com.thoughtworks.qdox.parser.impl;



//#line 2 "../src/grammar/parser.y"
import com.thoughtworks.qdox.parser.*;
import com.thoughtworks.qdox.parser.structs.*;
import java.io.IOException;
//#line 19 "Parser.java"




/**
 * Encapsulates yacc() parser functionality in a Java
 *        class for quick code development
 */
public class Parser
{

boolean yydebug;        //do I want debug output?
int yynerrs;            //number of errors so far
int yyerrflag;          //was there an error?
int yychar;             //the current working character

//########## MESSAGES ##########
//###############################################################
// method: debug
//###############################################################
void debug(String msg)
{
  if (yydebug)
    System.out.println(msg);
}

//########## STATE STACK ##########
final static int YYSTACKSIZE = 500;  //maximum stack size
int statestk[],stateptr;           //state stack
int stateptrmax;                     //highest index of stackptr
int statemax;                        //state when highest index reached
//###############################################################
// methods: state stack push,pop,drop,peek
//###############################################################
void state_push(int state)
{
  if (stateptr>=YYSTACKSIZE)         //overflowed?
    return;
  statestk[++stateptr]=state;
  if (stateptr>statemax)
    {
    statemax=state;
    stateptrmax=stateptr;
    }
}
int state_pop()
{
  if (stateptr<0)                    //underflowed?
    return -1;
  return statestk[stateptr--];
}
void state_drop(int cnt)
{
int ptr;
  ptr=stateptr-cnt;
  if (ptr<0)
    return;
  stateptr = ptr;
}
int state_peek(int relative)
{
int ptr;
  ptr=stateptr-relative;
  if (ptr<0)
    return -1;
  return statestk[ptr];
}
//###############################################################
// method: init_stacks : allocate and prepare stacks
//###############################################################
boolean init_stacks()
{
  statestk = new int[YYSTACKSIZE];
  stateptr = -1;
  statemax = -1;
  stateptrmax = -1;
  val_init();
  return true;
}
//###############################################################
// method: dump_stacks : show n levels of the stacks
//###############################################################
void dump_stacks(int count)
{
int i;
  System.out.println("=index==state====value=     s:"+stateptr+"  v:"+valptr);
  for (i=0;i<count;i++)
    System.out.println(" "+i+"    "+statestk[i]+"      "+valstk[i]);
  System.out.println("======================");
}


//########## SEMANTIC VALUES ##########
//## **user defined:Value
String   yytext;//user variable to return contextual strings
Value yyval; //used to return semantic vals from action routines
Value yylval;//the 'lval' (result) I got from yylex()
Value valstk[];
int valptr;
//###############################################################
// methods: value stack push,pop,drop,peek.
//###############################################################
void val_init()
{
  valstk=new Value[YYSTACKSIZE];
  yyval=new Value();
  yylval=new Value();
  valptr=-1;
}
void val_push(Value val)
{
  if (valptr>=YYSTACKSIZE)
    return;
  valstk[++valptr]=val;
}
Value val_pop()
{
  if (valptr<0)
    return null;
  return valstk[valptr--];
}
void val_drop(int cnt)
{
int ptr;
  ptr=valptr-cnt;
  if (ptr<0)
    return;
  valptr = ptr;
}
Value val_peek(int relative)
{
int ptr;
  ptr=valptr-relative;
  if (ptr<0)
    return null;
  return valstk[ptr];
}
//#### end semantic value section ####
public final static short SEMI=257;
public final static short DOT=258;
public final static short COMMA=259;
public final static short STAR=260;
public final static short EQUALS=261;
public final static short PACKAGE=262;
public final static short IMPORT=263;
public final static short PUBLIC=264;
public final static short PROTECTED=265;
public final static short PRIVATE=266;
public final static short STATIC=267;
public final static short FINAL=268;
public final static short ABSTRACT=269;
public final static short NATIVE=270;
public final static short STRICTFP=271;
public final static short SYNCHRONIZED=272;
public final static short TRANSIENT=273;
public final static short VOLATILE=274;
public final static short CLASS=275;
public final static short INTERFACE=276;
public final static short THROWS=277;
public final static short EXTENDS=278;
public final static short IMPLEMENTS=279;
public final static short BRACEOPEN=280;
public final static short BRACECLOSE=281;
public final static short SQUAREOPEN=282;
public final static short SQUARECLOSE=283;
public final static short PARENOPEN=284;
public final static short PARENCLOSE=285;
public final static short JAVADOCSTART=286;
public final static short JAVADOCEND=287;
public final static short CODEBLOCK=288;
public final static short STRING=289;
public final static short IDENTIFIER=290;
public final static short JAVADOCTAG=291;
public final static short JAVADOCTOKEN=292;
public final static short YYERRCODE=256;
final static short yylhs[] = {                           -1,
    0,    0,    6,    6,    6,    6,    7,    8,    9,   11,
   13,   13,   14,   12,   12,   16,   15,    1,    1,    1,
    5,    4,    3,    3,    2,    2,    2,    2,    2,    2,
    2,    2,    2,    2,    2,   17,   17,   10,   18,   20,
   20,   21,   21,   23,   23,   22,   22,   24,   24,   19,
   19,   25,   25,   25,   25,   25,   25,   25,   29,   29,
   31,   26,   30,   30,   27,   28,   32,   34,   34,   35,
   35,   33,   33,   37,   37,   36,   38,   38,
};
final static short yylen[] = {                            2,
    0,    2,    1,    1,    1,    1,    3,    3,    4,    1,
    0,    2,    1,    0,    2,    0,    3,    1,    3,    3,
    2,    2,    0,    3,    1,    1,    1,    1,    1,    1,
    1,    1,    1,    1,    1,    0,    2,    4,    5,    1,
    1,    0,    2,    1,    3,    0,    2,    1,    3,    0,
    2,    1,    1,    1,    1,    2,    1,    1,    1,    1,
    0,    6,    0,    3,    5,    4,    4,    0,    2,    1,
    3,    0,    2,    0,    3,    3,    0,    2,
};
final static short yydefred[] = {                         1,
    0,    0,    0,   11,    2,    3,    4,    5,    6,    0,
    0,   18,    0,    0,   14,    0,   25,   26,   27,   28,
   29,   30,   31,   35,   32,   34,   33,   40,   41,   37,
    0,   50,    7,    0,    8,    0,   13,   12,    0,    0,
   20,   19,    9,   16,   15,    0,    0,   58,   38,   52,
   57,    0,   51,   53,   54,   55,   11,    0,    0,    0,
   39,   56,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,   61,    0,    0,    0,   74,    0,   59,
   60,   66,    0,    0,    0,   63,    0,    0,    0,   78,
    0,   24,   65,    0,    0,   67,   77,   23,   76,    0,
   62,    0,    0,   75,   64,    0,    0,
};
final static short yydgoto[] = {                          1,
   64,   30,   84,   65,   74,    5,    6,    7,    8,    9,
   15,   36,   16,   38,   45,   57,   10,   11,   40,   31,
   47,   61,   59,   69,   53,   54,   55,   56,   82,   94,
   86,   71,   77,   96,  103,   78,   89,   79,
};
final static short yysindex[] = {                         0,
 -244, -270, -270,    0,    0,    0,    0,    0,    0, -108,
 -257,    0, -191, -186,    0, -267,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
 -260,    0,    0, -239,    0, -237,    0,    0, -219, -254,
    0,    0,    0,    0,    0, -270, -215,    0,    0,    0,
    0, -189,    0,    0,    0,    0,    0, -220, -171, -270,
    0,    0, -216, -220, -217, -267, -270, -220, -165,    0,
 -242, -187, -216,    0, -220, -270, -185,    0, -119,    0,
    0,    0, -181, -187, -242,    0, -220, -180, -163,    0,
 -192,    0,    0, -249, -270,    0,    0,    0,    0, -192,
    0, -220, -156,    0,    0, -270, -220,
};
final static short yyrindex[] = {                         0,
  -92,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0, -234,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0, -190, -159,
    0,    0,    0,    0,    0,    0, -150,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0, -218, -188,    0,
    0,    0, -256, -227,    0, -231,    0, -235, -148, -146,
    0, -157, -253,    0, -210,    0,    0,    0,    0,    0,
    0,    0,    0, -252,    0,    0, -228, -241, -151,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0, -248, -240,    0,    0,    0, -245,
};
final static short yygindex[] = {                         0,
   -2,   56,   72,   58,  -78,    0,    0,    0,   98,  100,
    0,    0,   84,    0,    0,    0,  102,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,  -57,    0,
    0,   70,    0,    0,    0,   73,    0,    0,
};
final static int YYTABLESIZE=184;
final static short yytable[] = {                         13,
   14,   18,   48,   23,   21,   23,   21,   80,   70,  100,
   70,   71,   99,   71,   80,   68,   69,    2,    3,   12,
   41,  105,   32,   48,   37,   18,   49,   93,   23,   39,
   49,    4,   21,   18,   23,   21,  101,   34,   81,   70,
   44,    4,   71,   58,   48,   81,   68,   69,   45,   43,
   42,   49,   10,   44,   23,   17,   10,   68,   46,   17,
   44,   44,   23,   60,   75,   33,   34,   70,   45,   45,
   35,   34,   73,   87,   17,   18,   19,   20,   21,   22,
   23,   24,   25,   26,   27,   28,   29,   67,   42,   42,
   43,   43,  102,   76,   83,   97,   95,   98,   62,   88,
   63,   92,  106,  107,   36,   36,   36,   36,   36,   36,
   36,   36,   36,   36,   36,   36,   36,   77,   77,   77,
   77,   77,   77,   77,   77,   77,   77,   77,   36,   46,
   36,   47,   22,   73,   90,   72,   91,   50,   72,   51,
   66,   52,   85,   77,   17,   18,   19,   20,   21,   22,
   23,   24,   25,   26,   27,   17,   18,   19,   20,   21,
   22,   23,   24,   25,   26,   27,   28,   29,    0,  104,
   12,   36,   36,   36,   36,   36,   36,   36,   36,   36,
   36,   36,   36,   36,
};
final static short yycheck[] = {                          2,
    3,  258,  257,  257,  257,  259,  259,  257,  257,  259,
  259,  257,   91,  259,  257,  257,  257,  262,  263,  290,
  260,  100,  280,  259,  292,  282,  281,   85,  282,  290,
  259,  286,  285,  290,  288,  288,   94,  258,  288,  288,
  259,  286,  288,   46,  280,  288,  288,  288,  259,  287,
  290,  280,  287,  291,  282,  287,  291,   60,  278,  291,
  279,  280,  290,  279,   67,  257,  258,  284,  279,  280,
  257,  258,  290,   76,  264,  265,  266,  267,  268,  269,
  270,  271,  272,  273,  274,  275,  276,  259,  279,  280,
  279,  280,   95,  259,  282,  259,  277,  290,  288,  285,
  290,  283,  259,  106,  264,  265,  266,  267,  268,  269,
  270,  271,  272,  273,  274,  275,  276,  264,  265,  266,
  267,  268,  269,  270,  271,  272,  273,  274,  288,  280,
  290,  280,  290,  285,   79,   64,   79,   40,  285,   40,
   57,   40,   73,  290,  264,  265,  266,  267,  268,  269,
  270,  271,  272,  273,  274,  264,  265,  266,  267,  268,
  269,  270,  271,  272,  273,  274,  275,  276,   -1,   97,
  290,  264,  265,  266,  267,  268,  269,  270,  271,  272,
  273,  274,  275,  276,
};
final static short YYFINAL=1;
final static short YYMAXTOKEN=292;
final static String yyname[] = {
"end-of-file",null,null,null,null,null,null,null,null,null,null,null,null,null,
null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,
null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,
null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,
null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,
null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,
null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,
null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,
null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,
null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,
null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,
null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,
null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,
null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,
null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,
null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,
null,null,null,"SEMI","DOT","COMMA","STAR","EQUALS","PACKAGE","IMPORT","PUBLIC",
"PROTECTED","PRIVATE","STATIC","FINAL","ABSTRACT","NATIVE","STRICTFP",
"SYNCHRONIZED","TRANSIENT","VOLATILE","CLASS","INTERFACE","THROWS","EXTENDS",
"IMPLEMENTS","BRACEOPEN","BRACECLOSE","SQUAREOPEN","SQUARECLOSE","PARENOPEN",
"PARENCLOSE","JAVADOCSTART","JAVADOCEND","CODEBLOCK","STRING","IDENTIFIER",
"JAVADOCTAG","JAVADOCTOKEN",
};
final static String yyrule[] = {
"$accept : file",
"file :",
"file : file filepart",
"filepart : package",
"filepart : import",
"filepart : javadoc",
"filepart : class",
"package : PACKAGE fullidentifier SEMI",
"import : IMPORT fullidentifier SEMI",
"javadoc : JAVADOCSTART javadocdescription javadoctags JAVADOCEND",
"javadocdescription : javadoctokens",
"javadoctokens :",
"javadoctokens : javadoctokens javadoctoken",
"javadoctoken : JAVADOCTOKEN",
"javadoctags :",
"javadoctags : javadoctags javadoctag",
"$$1 :",
"javadoctag : JAVADOCTAG $$1 javadoctokens",
"fullidentifier : IDENTIFIER",
"fullidentifier : fullidentifier DOT IDENTIFIER",
"fullidentifier : fullidentifier DOT STAR",
"arrayidentifier : IDENTIFIER dimensions",
"type : fullidentifier dimensions",
"dimensions :",
"dimensions : dimensions SQUAREOPEN SQUARECLOSE",
"modifier : PUBLIC",
"modifier : PROTECTED",
"modifier : PRIVATE",
"modifier : STATIC",
"modifier : FINAL",
"modifier : ABSTRACT",
"modifier : NATIVE",
"modifier : SYNCHRONIZED",
"modifier : VOLATILE",
"modifier : TRANSIENT",
"modifier : STRICTFP",
"modifiers :",
"modifiers : modifiers modifier",
"class : classdefinition BRACEOPEN members BRACECLOSE",
"classdefinition : modifiers classorinterface IDENTIFIER extends implements",
"classorinterface : CLASS",
"classorinterface : INTERFACE",
"extends :",
"extends : EXTENDS extendslist",
"extendslist : fullidentifier",
"extendslist : extendslist COMMA fullidentifier",
"implements :",
"implements : IMPLEMENTS implementslist",
"implementslist : fullidentifier",
"implementslist : implementslist COMMA fullidentifier",
"members :",
"members : members member",
"member : javadoc",
"member : fields",
"member : method",
"member : constructor",
"member : modifiers CODEBLOCK",
"member : class",
"member : SEMI",
"memberend : SEMI",
"memberend : CODEBLOCK",
"$$2 :",
"fields : modifiers type arrayidentifier $$2 extrafields memberend",
"extrafields :",
"extrafields : extrafields COMMA arrayidentifier",
"method : modifiers type IDENTIFIER methoddef memberend",
"constructor : modifiers IDENTIFIER methoddef memberend",
"methoddef : PARENOPEN params PARENCLOSE exceptions",
"exceptions :",
"exceptions : THROWS exceptionlist",
"exceptionlist : fullidentifier",
"exceptionlist : exceptionlist COMMA fullidentifier",
"params :",
"params : param paramlist",
"paramlist :",
"paramlist : paramlist COMMA param",
"param : parammodifiers type arrayidentifier",
"parammodifiers :",
"parammodifiers : parammodifiers modifier",
};

//#line 210 "../src/grammar/parser.y"

private Lexer lexer;
private Builder builder;
private StringBuffer textBuffer = new StringBuffer();
private ClassDef cls = new ClassDef();
private MethodDef mth = new MethodDef();
private FieldDef param = new FieldDef();
private java.util.Set modifiers = new java.util.HashSet();
private TypeDef fieldType;
private int tagLine;

private String buffer() {
    if (textBuffer.length() > 0) textBuffer.deleteCharAt(textBuffer.length() - 1);
    String result = textBuffer.toString();
    textBuffer.setLength(0);
    return result;
}

public Parser(Lexer lexer, Builder builder) {
    this.lexer = lexer;
    this.builder = builder;
}

/**
 * Parse file. Return true if successful.
 */
public boolean parse() {
    return yyparse() == 0;
}

private int yylex() {
    try {
        final int result = lexer.lex();
        yylval = new Value();
        yylval.sval = lexer.text();
        return result;
    }
    catch(IOException e) {
        return 0;
    }
}

private void yyerror(String msg) {
    throw new ParseException(msg, lexer.getLine(), lexer.getColumn());
}

private class Value {
    String sval;
    int ival;
    TypeDef type;
}

private void makeField(TypeDef field) {
    FieldDef fd = new FieldDef();
    fd.modifiers.addAll(modifiers); 
    fd.type = fieldType.name; 
    fd.dimensions = fieldType.dimensions + field.dimensions;
    fd.name = field.name;
    builder.addField(fd);
}
            
//#line 429 "Parser.java"
//###############################################################
// method: yylexdebug : check lexer state
//###############################################################
void yylexdebug(int state,int ch)
{
String s=null;
  if (ch < 0) ch=0;
  if (ch <= YYMAXTOKEN) //check index bounds
     s = yyname[ch];    //now get it
  if (s==null)
    s = "illegal-symbol";
  debug("state "+state+", reading "+ch+" ("+s+")");
}





//The following are now global, to aid in error reporting
int yyn;       //next next thing to do
int yym;       //
int yystate;   //current parsing state from state table
String yys;    //current token string


//###############################################################
// method: yyparse : parse input and execute indicated items
//###############################################################
int yyparse()
{
boolean doaction;
  init_stacks();
  yynerrs = 0;
  yyerrflag = 0;
  yychar = -1;          //impossible char forces a read
  yystate=0;            //initial state
  state_push(yystate);  //save it
  while (true) //until parsing is done, either correctly, or w/error
    {
    doaction=true;
    if (yydebug) debug("loop"); 
    //#### NEXT ACTION (from reduction table)
    for (yyn=yydefred[yystate];yyn==0;yyn=yydefred[yystate])
      {
      if (yydebug) debug("yyn:"+yyn+"  state:"+yystate+"  yychar:"+yychar);
      if (yychar < 0)      //we want a char?
        {
        yychar = yylex();  //get next token
        if (yydebug) debug(" next yychar:"+yychar);
        //#### ERROR CHECK ####
        if (yychar < 0)    //it it didn't work/error
          {
          yychar = 0;      //change it to default string (no -1!)
          if (yydebug)
            yylexdebug(yystate,yychar);
          }
        }//yychar<0
      yyn = yysindex[yystate];  //get amount to shift by (shift index)
      if ((yyn != 0) && (yyn += yychar) >= 0 &&
          yyn <= YYTABLESIZE && yycheck[yyn] == yychar)
        {
        if (yydebug)
          debug("state "+yystate+", shifting to state "+yytable[yyn]);
        //#### NEXT STATE ####
        yystate = yytable[yyn];//we are in a new state
        state_push(yystate);   //save it
        val_push(yylval);      //push our lval as the input for next rule
        yychar = -1;           //since we have 'eaten' a token, say we need another
        if (yyerrflag > 0)     //have we recovered an error?
           --yyerrflag;        //give ourselves credit
        doaction=false;        //but don't process yet
        break;   //quit the yyn=0 loop
        }

    yyn = yyrindex[yystate];  //reduce
    if ((yyn !=0 ) && (yyn += yychar) >= 0 &&
            yyn <= YYTABLESIZE && yycheck[yyn] == yychar)
      {   //we reduced!
      if (yydebug) debug("reduce");
      yyn = yytable[yyn];
      doaction=true; //get ready to execute
      break;         //drop down to actions
      }
    else //ERROR RECOVERY
      {
      if (yyerrflag==0)
        {
        yyerror("syntax error");
        yynerrs++;
        }
      if (yyerrflag < 3) //low error count?
        {
        yyerrflag = 3;
        while (true)   //do until break
          {
          if (stateptr<0)   //check for under & overflow here
            {
            yyerror("stack underflow. aborting...");  //note lower case 's'
            return 1;
            }
          yyn = yysindex[state_peek(0)];
          if ((yyn != 0) && (yyn += YYERRCODE) >= 0 &&
                    yyn <= YYTABLESIZE && yycheck[yyn] == YYERRCODE)
            {
            if (yydebug)
              debug("state "+state_peek(0)+", error recovery shifting to state "+yytable[yyn]+" ");
            yystate = yytable[yyn];
            state_push(yystate);
            val_push(yylval);
            doaction=false;
            break;
            }
          else
            {
            if (yydebug)
              debug("error recovery discarding state "+state_peek(0)+" ");
            if (stateptr<0)   //check for under & overflow here
              {
              yyerror("Stack underflow. aborting...");  //capital 'S'
              return 1;
              }
            state_pop();
            val_pop();
            }
          }
        }
      else            //discard this token
        {
        if (yychar == 0)
          return 1; //yyabort
        if (yydebug)
          {
          yys = null;
          if (yychar <= YYMAXTOKEN) yys = yyname[yychar];
          if (yys == null) yys = "illegal-symbol";
          debug("state "+yystate+", error recovery discards token "+yychar+" ("+yys+")");
          }
        yychar = -1;  //read another
        }
      }//end error recovery
    }//yyn=0 loop
    if (!doaction)   //any reason not to proceed?
      continue;      //skip action
    yym = yylen[yyn];          //get count of terminals on rhs
    if (yydebug)
      debug("state "+yystate+", reducing "+yym+" by rule "+yyn+" ("+yyrule[yyn]+")");
    if (yym>0)                 //if count of rhs not 'nil'
      yyval = val_peek(yym-1); //get current semantic value
    switch(yyn)
      {
//########## USER-SUPPLIED ACTIONS ##########
case 7:
//#line 32 "../src/grammar/parser.y"
{ builder.addPackage(val_peek(1).sval); }
break;
case 8:
//#line 35 "../src/grammar/parser.y"
{ builder.addImport(val_peek(1).sval); }
break;
case 10:
//#line 43 "../src/grammar/parser.y"
{ 
        builder.addJavaDoc(buffer()); 
    }
break;
case 13:
//#line 50 "../src/grammar/parser.y"
{ 
        textBuffer.append(val_peek(0).sval); textBuffer.append(' '); 
    }
break;
case 16:
//#line 57 "../src/grammar/parser.y"
{ tagLine = lexer.getLine(); }
break;
case 17:
//#line 58 "../src/grammar/parser.y"
{
        builder.addJavaDocTag(val_peek(2).sval.substring(1), buffer(), tagLine); 
    }
break;
case 18:
//#line 67 "../src/grammar/parser.y"
{ yyval.sval = val_peek(0).sval; }
break;
case 19:
//#line 68 "../src/grammar/parser.y"
{ yyval.sval = val_peek(2).sval + '.' + val_peek(0).sval; }
break;
case 20:
//#line 69 "../src/grammar/parser.y"
{ yyval.sval = val_peek(2).sval + ".*"; }
break;
case 21:
//#line 72 "../src/grammar/parser.y"
{
        yyval.type = new TypeDef(val_peek(1).sval,val_peek(0).ival); 
    }
break;
case 22:
//#line 77 "../src/grammar/parser.y"
{ 
        yyval.type = new TypeDef(val_peek(1).sval,val_peek(0).ival); 
    }
break;
case 23:
//#line 82 "../src/grammar/parser.y"
{ yyval.ival = 0; }
break;
case 24:
//#line 83 "../src/grammar/parser.y"
{
        yyval.ival = val_peek(2).ival + 1; 
    }
break;
case 25:
//#line 89 "../src/grammar/parser.y"
{ yyval.sval = "public"; }
break;
case 26:
//#line 90 "../src/grammar/parser.y"
{ yyval.sval = "protected"; }
break;
case 27:
//#line 91 "../src/grammar/parser.y"
{ yyval.sval = "private"; }
break;
case 28:
//#line 92 "../src/grammar/parser.y"
{ yyval.sval = "static"; }
break;
case 29:
//#line 93 "../src/grammar/parser.y"
{ yyval.sval = "final"; }
break;
case 30:
//#line 94 "../src/grammar/parser.y"
{ yyval.sval = "abstract"; }
break;
case 31:
//#line 95 "../src/grammar/parser.y"
{ yyval.sval = "native"; }
break;
case 32:
//#line 96 "../src/grammar/parser.y"
{ yyval.sval = "synchronized"; }
break;
case 33:
//#line 97 "../src/grammar/parser.y"
{ yyval.sval = "volatile"; }
break;
case 34:
//#line 98 "../src/grammar/parser.y"
{ yyval.sval = "transient"; }
break;
case 35:
//#line 99 "../src/grammar/parser.y"
{ yyval.sval = "strictfp"; }
break;
case 37:
//#line 101 "../src/grammar/parser.y"
{ modifiers.add(val_peek(0).sval); }
break;
case 38:
//#line 107 "../src/grammar/parser.y"
{ 
        builder.endClass(); 
    }
break;
case 39:
//#line 112 "../src/grammar/parser.y"
{ 
        cls.modifiers.addAll(modifiers); modifiers.clear(); 
        cls.name = val_peek(2).sval; 
        builder.beginClass(cls); 
        cls = new ClassDef(); 
    }
break;
case 41:
//#line 121 "../src/grammar/parser.y"
{ cls.isInterface = true; }
break;
case 44:
//#line 126 "../src/grammar/parser.y"
{ cls.extendz.add(val_peek(0).sval); }
break;
case 45:
//#line 127 "../src/grammar/parser.y"
{ cls.extendz.add(val_peek(0).sval); }
break;
case 48:
//#line 132 "../src/grammar/parser.y"
{ cls.implementz.add(val_peek(0).sval); }
break;
case 49:
//#line 133 "../src/grammar/parser.y"
{ cls.implementz.add(val_peek(0).sval); }
break;
case 61:
//#line 152 "../src/grammar/parser.y"
{
        fieldType = val_peek(1).type;
        makeField(val_peek(0).type);
    }
break;
case 62:
//#line 156 "../src/grammar/parser.y"
{
        modifiers.clear();
    }
break;
case 64:
//#line 161 "../src/grammar/parser.y"
{
        makeField(val_peek(0).type);
    }
break;
case 65:
//#line 169 "../src/grammar/parser.y"
{
        mth.modifiers.addAll(modifiers); modifiers.clear(); 
        mth.returns = val_peek(3).type.name; mth.dimensions = val_peek(3).type.dimensions; 
        mth.name = val_peek(2).sval; 
        builder.addMethod(mth);
        mth = new MethodDef(); 
    }
break;
case 66:
//#line 178 "../src/grammar/parser.y"
{ 
        mth.modifiers.addAll(modifiers); modifiers.clear(); 
        mth.constructor = true; mth.name = val_peek(2).sval; 
        builder.addMethod(mth);
        mth = new MethodDef(); 
    }
break;
case 70:
//#line 190 "../src/grammar/parser.y"
{ mth.exceptions.add(val_peek(0).sval); }
break;
case 71:
//#line 191 "../src/grammar/parser.y"
{ mth.exceptions.add(val_peek(0).sval); }
break;
case 76:
//#line 198 "../src/grammar/parser.y"
{ 
        param.name = val_peek(0).type.name; 
        param.type = val_peek(1).type.name; 
        param.dimensions = val_peek(1).type.dimensions + val_peek(0).type.dimensions; 
        mth.params.add(param); param = new FieldDef(); 
    }
break;
case 78:
//#line 206 "../src/grammar/parser.y"
{ param.modifiers.add(val_peek(0).sval); }
break;
//#line 782 "Parser.java"
//########## END OF USER-SUPPLIED ACTIONS ##########
    }//switch
    //#### Now let's reduce... ####
    if (yydebug) debug("reduce");
    state_drop(yym);             //we just reduced yylen states
    yystate = state_peek(0);     //get new state
    val_drop(yym);               //corresponding value drop
    yym = yylhs[yyn];            //select next TERMINAL(on lhs)
    if (yystate == 0 && yym == 0)//done? 'rest' state and at first TERMINAL
      {
      debug("After reduction, shifting from state 0 to state "+YYFINAL+"");
      yystate = YYFINAL;         //explicitly say we're done
      state_push(YYFINAL);       //and save it
      val_push(yyval);           //also save the semantic value of parsing
      if (yychar < 0)            //we want another character?
        {
        yychar = yylex();        //get next character
        if (yychar<0) yychar=0;  //clean, if necessary
        if (yydebug)
          yylexdebug(yystate,yychar);
        }
      if (yychar == 0)          //Good exit (if lex returns 0 ;-)
         break;                 //quit the loop--all DONE
      }//if yystate
    else                        //else not done yet
      {                         //get next state and push, for next yydefred[]
      yyn = yygindex[yym];      //find out where to go
      if ((yyn != 0) && (yyn += yystate) >= 0 &&
            yyn <= YYTABLESIZE && yycheck[yyn] == yystate)
        yystate = yytable[yyn]; //get new state
      else
        yystate = yydgoto[yym]; //else go to new defred
      debug("after reduction, shifting from state "+state_peek(0)+" to state "+yystate+"");
      state_push(yystate);     //going again, so push state & val...
      val_push(yyval);         //for next action
      }
    }//main loop
  return 0;//yyaccept!!
}
//## end of method parse() ######################################



//## run() --- for Thread #######################################
//## The -Jnorun option was used ##
//## end of method run() ########################################



//## Constructors ###############################################
//## The -Jnoconstruct option was used ##
//###############################################################



}
//################### END OF CLASS ##############################
