%define section free

Summary:        Extract class/interface/method definitions from sources
Name:           qdox
Version:        1.4
Release:        1jpp
Epoch:          0
License:        Apache-style Software License
URL:            http://qdox.codehaus.org/
Group:          Development/Libraries/Java
Vendor:         JPackage Project
Distribution:   JPackage
Source0:        qdox-src-1.4.tar.gz
# cvs -d :pserver:anonymous@cvs.qdox.codehaus.org:/home/projects/qdox/scm login
#  cvs -z3 -d :pserver:anonymous@cvs.qdox.codehaus.org:/home/projects/qdox/scm  export -r QDOX_1_4 qdox
Source1:        qdox-build.xml
Source2:        qdox-Parser.java
Source3:        qdox-JFlexLexer.java
Patch0:         qdox-DirectoryScannerTest.patch
BuildRequires:  jpackage-utils >= 0:1.5.37
BuildRequires:  ant >= 0:1.5.4, ant-optional >= 0:1.5.4
BuildRequires:  junit >= 0:3.8.1
BuildRequires:  jmock >= 0:1.0
BuildRequires:  mockobjects >= 0:0.09
BuildArch:      noarch
BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-buildroot

%description
QDox is a high speed, small footprint parser 
for extracting class/interface/method definitions 
from source files complete with JavaDoc @tags. 
It is designed to be used by active code 
generators or documentation tools. 

%package javadoc
Summary:        Javadoc for %{name}
Group:          Development/Documentation

%description javadoc
%{summary}.

%prep
%setup -q -n %{name}
cp %{SOURCE1} build.xml
mkdir -p src/java/com/thoughtworks/qdox/parser/impl
cp %{SOURCE2} src/java/com/thoughtworks/qdox/parser/impl/Parser.java
cp %{SOURCE3} src/java/com/thoughtworks/qdox/parser/impl/JFlexLexer.java
cp src/test/com/thoughtworks/qdox/directorywalker/DirectoryScannerTest.java src/test/com/thoughtworks/qdox/directorywalker/DirectoryScannerTest.java.sav

%patch0

%build
export CLASSPATH=$(build-classpath \
ant \
ant-optional \
jmock \
mockobjects-core \
junit)
CLASSPATH=target/classes:target/test-classes:$CLASSPATH
ant -Dbuild.sysclasspath=only dist

%install
rm -rf $RPM_BUILD_ROOT

# jars
mkdir -p $RPM_BUILD_ROOT%{_javadir}
cp -p target/%{name}-%{version}.jar \
      $RPM_BUILD_ROOT%{_javadir}/%{name}-%{version}.jar
(cd $RPM_BUILD_ROOT%{_javadir} && for jar in *-%{version}.jar; do ln -sf ${jar} `echo $jar| sed "s|-%{version}||g"`; done)

# javadoc
mkdir -p $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}
cp -pr dist/docs/api/* $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}
ln -s %{name}-%{version} $RPM_BUILD_ROOT%{_javadocdir}/%{name} # ghost symlink


%clean
rm -rf $RPM_BUILD_ROOT

%post javadoc
rm -f %{_javadocdir}/%{name}
ln -s %{name}-%{version} %{_javadocdir}/%{name}

%postun javadoc
if [ "$1" = "0" ]; then
  rm -f %{_javadocdir}/%{name}
fi

%files
%defattr(0644,root,root,0755)
%doc LICENSE.txt
%{_javadir}/%{name}.jar
%{_javadir}/%{name}-%{version}.jar

%files javadoc
%defattr(0644,root,root,0755)
%doc %{_javadocdir}

%changelog

* Mon Jun 07 2004 Ralph Apel <r.apel at r-apel.de> - 0:1.4-1jpp
- Upgrade to 1.4
- Drop Requires: mockobjects (Build/Test only)

* Tue Feb 24 2004 Ralph Apel <r.apel at r-apel.de> - 0:1.3-1jpp
- First JPackage release
